﻿using ASPMVCRouting2.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

/////////////////////////////////////////////////
//      www.interestprograms.ru
//      Программы, игры и их исходные коды
////////////////////////////////////////////////

namespace ASPMVCRouting2.Controllers
{
    public class MainController : Controller
    {

        private string _Catalog = null;
        private string _Element = null;
        private string _Item = null;
        private enum Result {retAction, retElement, retItem};
        private Result _result = Result.retAction;

        // Метод вызывается перед исполнением каждого Action
        // и позволяет получать основные ланные текущего Action 
        protected override void OnActionExecuting(ActionExecutingContext ctx)
        {
            // Чтобы имена контроллера и метода 
            _Catalog = ctx.RouteData.Values["action"].ToString();


            // Идентификаторы элементов и пунктов можно получать и таким образом 

            if (ctx.RouteData.Values["element"] != null)
            {
                _Element = ctx.RouteData.Values["element"].ToString();

                _result = Result.retElement;
            }

            if (ctx.RouteData.Values["item"] != null)
            {
                _Item = ctx.RouteData.Values["item"].ToString();

                _result = Result.retItem;
            }
        }



        // GET: Home
        public ActionResult Index()
        {

            GetData getData = new GetData();

            return View(getData);
        }

        // Атрибут для изменения вызываемого имени метода.
        // В отличие от метода C# в названии которого нельзя применять дефисы
        // атрибут позволяет использовать любое имя.
        // При загрузке страницы будет использоваться атрибутное имя метода. 
        [ActionName("electro-lampy")]
        public ActionResult ElectroLampy()
        {
            GetData getData = null;

            switch(_result)
            {
                case Result.retElement:
                    getData = Common.Element(_Catalog, _Element);

                    return View(Common.UrlElement, getData);
                case Result.retItem:
                    getData = Common.Item(_Catalog, _Element, _Item);

                    return View(Common.UrlItem, getData);
            }

            getData = new GetData();
            getData.PrepareCatalog(_Catalog);

            return View(Common.UrlCatalog, getData);
        }


        // Атрибут для изменения вызываемого имени метода.
        // В отличие от метода C# в названии которого нельзя применять дефисы
        // атрибут позволяет использовать любое имя.
        // При загрузке страницы будет использоваться атрибутное имя метода. 
        [ActionName("istochniki-pitaniya")]
        public ActionResult IstochnikiPitaniya()
        {
            GetData getData = null;

            switch (_result)
            {
                case Result.retElement:
                    getData = Common.Element(_Catalog, _Element);

                    return View(Common.UrlElement, getData);
                case Result.retItem:
                    getData = Common.Item(_Catalog, _Element, _Item);

                    return View(Common.UrlItem, getData);
            }

            getData = new GetData();
            getData.PrepareCatalog(_Catalog);

            return View(Common.UrlCatalog, getData);
        }


        // Атрибут для изменения вызываемого имени метода.
        // В отличие от метода C# в названии которого нельзя применять дефисы
        // атрибут позволяет использовать любое имя.
        // При загрузке страницы будет использоваться атрибутное имя метода. 
        [ActionName("izmeritelnye-pribory")]
        public ActionResult IzmeritelnyePribory()
        {
            GetData getData;

            switch (_result)
            {
                case Result.retElement:
                    getData = Common.Element(_Catalog, _Element);

                    return View(Common.UrlElement, getData);
                case Result.retItem:
                    getData = Common.Item(_Catalog, _Element, _Item);

                    return View(Common.UrlItem, getData);
            }

            getData = new GetData();
            getData.PrepareCatalog(_Catalog);

            return View(Common.UrlCatalog, getData);
        }


    }
}